glibmm: Gio::Cancellable Class Reference

# Gio::Cancellable Class Reference

Allows actions to be cancelled. More...

`#include <giomm/cancellable.h>`

Inheritance diagram for Gio::Cancellable:
[legend]

List of all members.

## Public Types

typedef sigc::slot< void > | SlotCancelledCallback

## Public Member Functions

virtual | ~Cancellable ()
GCancellable* | gobj ()
| Provides access to the underlying C GObject.
const GCancellable* | gobj () const
| Provides access to the underlying C GObject.
GCancellable* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | is_cancelled () const
| Checks if a cancellable job has been cancelled.
int | get_fd () const
| Gets the file descriptor for a cancellable job.
bool | make_pollfd (GPollFD* pollfd)
| Creates a PollFD corresponding to cancellable; this can be passed to Glib::poll() and used to poll for cancellation.
void | release_fd ()
| Releases a resources previously allocated by g_cancellable_get_fd() or g_cancellable_make_pollfd().
void | cancel ()
| Will set cancellable to cancelled, and will emit the Cancellable::cancelled signal.
void | push_current ()
| Pushes cancellable onto the cancellable stack.
void | pop_current ()
| Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).
void | reset ()
| Resets cancellable to its uncancelled state.
gulong | connect (const SlotCancelledCallback& callback)
| Convenience function to connect to the Cancellable::cancelled signal.
void | disconnect (gulong handler_id)
| Disconnects a handler from a cancellable instance similar to Glib::signal_handler_disconnect().
Glib::SignalProxy0< void > | signal_cancelled ()

## Static Public Member Functions

static Glib::RefPtr< Cancellable > | create ()
static Glib::RefPtr< Cancellable > | get_current ()
| Gets the top cancellable from the stack.

## Protected Member Functions

| Cancellable ()
virtual void | on_cancelled ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::Cancellable > | wrap (GCancellable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Allows actions to be cancelled.

Cancellable is a thread-safe operation cancellation stack used throughout GIO to allow for cancellation of synchronous and asynchronous operations.

Since glibmm 2.16:

## Member Typedef Documentation

typedef sigc::slot<void> Gio::Cancellable::SlotCancelledCallback

## Constructor & Destructor Documentation

virtual Gio::Cancellable::~Cancellable | ( |  | ) | `[virtual]`

Gio::Cancellable::Cancellable | ( |  | ) | `[protected]`

## Member Function Documentation

void Gio::Cancellable::cancel | ( |  | ) |

Will set cancellable to cancelled, and will emit the Cancellable::cancelled signal.

(However, see the warning about race conditions in the documentation for that signal if you are planning to connect to it.)

This function is thread-safe. In other words, you can safely call it from a thread other than the one running the operation that was passed the cancellable.

The convention within gio is that cancelling an asynchronous operation causes it to complete asynchronously. That is, if you cancel the operation from the same thread in which it is running, then the operation's AsyncReadyCallback will not be invoked until the application returns to the main loop.

gulong Gio::Cancellable::connect | ( | const SlotCancelledCallback & | callback | ) |

Convenience function to connect to the Cancellable::cancelled signal.

Also handles the race condition that may happen if the cancellable is cancelled right before connecting.

callback is called at most once, either directly at the time of the connect if cancellable is already cancelled, or when cancellable is cancelled in some thread.

data_destroy_func will be called when the handler is disconnected, or immediately if the cancellable is already cancelled.

See Cancellable::cancelled for details on how to use this.

Since glibmm 2.22:

Parameters:

  | callback | The Callback to connect.
  | data | Data to pass to callback.
  | data_destroy_func | Free function for data or `0`.

Returns:
  The id of the signal handler or 0 if cancellable has already been cancelled.

static Glib::RefPtr<Cancellable> Gio::Cancellable::create | ( |  | ) | `[static]`

void Gio::Cancellable::disconnect | ( | gulong | handler_id | ) |

Disconnects a handler from a cancellable instance similar to Glib::signal_handler_disconnect().

Additionally, in the event that a signal handler is currently running, this call will block until the handler has finished. Calling this function from a Cancellable::cancelled signal handler will therefore result in a deadlock.

This avoids a race condition where a thread cancels at the same time as the cancellable operation is finished and the signal handler is removed. See Cancellable::cancelled for details on how to use this.

If cancellable is `0` or handler_id is 0 this function does nothing.

Since glibmm 2.22:

Parameters:

  | handler_id | Handler id of the handler to be disconnected, or 0.

static Glib::RefPtr<Cancellable> Gio::Cancellable::get_current | ( |  | ) | `[static]`

Gets the top cancellable from the stack.

Returns:
  A Cancellable from the top of the stack, or `0` if the stack is empty.

int Gio::Cancellable::get_fd | ( |  | ) | const

Gets the file descriptor for a cancellable job.

This can be used to implement cancellable operations on Unix systems. The returned fd will turn readable when cancellable is cancelled.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with g_cancellable_reset().

After a successful return from this function, you should use g_cancellable_release_fd() to free up resources allocated for the returned file descriptor.

See also g_cancellable_make_pollfd().

Returns:
  A valid file descriptor. -1 if the file descriptor is not supported, or on errors.

const GCancellable* Gio::Cancellable::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GCancellable* Gio::Cancellable::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GCancellable* Gio::Cancellable::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::Cancellable::is_cancelled | ( |  | ) | const

Checks if a cancellable job has been cancelled.

Returns:
  `true` if cancellable is cancelled, `false` if called with `0` or if item is not cancelled.

bool Gio::Cancellable::make_pollfd | ( | GPollFD * | pollfd | ) |

Creates a PollFD corresponding to cancellable; this can be passed to Glib::poll() and used to poll for cancellation.

This is useful both for unix systems without a native poll and for portability to windows.

When this function returns `true`, you should use g_cancellable_release_fd() to free up resources allocated for the pollfd. After a `false` return, do not call g_cancellable_release_fd().

If this function returns `false`, either no cancellable was given or resource limits prevent this function from allocating the necessary structures for polling. (On Linux, you will likely have reached the maximum number of file descriptors.) The suggested way to handle these cases is to ignore the cancellable.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with g_cancellable_reset().

Since glibmm 2.22:

Parameters:

  | pollfd | A pointer to a PollFD.

Returns:
  `true` if pollfd was successfully initialized, `false` on failure to prepare the cancellable.

virtual void Gio::Cancellable::on_cancelled | ( |  | ) | `[protected, virtual]`

void Gio::Cancellable::pop_current | ( |  | ) |

Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).

void Gio::Cancellable::push_current | ( |  | ) |

Pushes cancellable onto the cancellable stack.

The current cancllable can then be recieved using g_cancellable_get_current().

This is useful when implementing cancellable operations in code that does not allow you to pass down the cancellable object.

This is typically called automatically by e.g. File operations, so you rarely have to call this yourself.

void Gio::Cancellable::release_fd | ( |  | ) |

Releases a resources previously allocated by g_cancellable_get_fd() or g_cancellable_make_pollfd().

For compatibility reasons with older releases, calling this function is not strictly required, the resources will be automatically freed when the cancellable is finalized. However, the cancellable will block scarce file descriptors until it is finalized if this function is not called. This can cause the application to run out of file descriptors when many Cancellables are used at the same time.

Since glibmm 2.22:

void Gio::Cancellable::reset | ( |  | ) |

Resets cancellable to its uncancelled state.

Glib::SignalProxy0< void > Gio::Cancellable::signal_cancelled | ( |  | ) |

Prototype:
  `void on_my_cancelled()`

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Cancellable > wrap | ( | GCancellable * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.